Boot up nginx as standalone server instead of using netcat.
[discourse_docker.git] / launcher
CommitLineData
ace450bd 1#!/bin/bash
7e738616 2
5cb39519 3usage () {
c2d3ee4a 4 echo "Usage: launcher COMMAND CONFIG [--skip-prereqs] [--docker-args STRING]"
5cb39519
JA
5 echo "Commands:"
6 echo " start: Start/initialize a container"
7 echo " stop: Stop a running container"
8 echo " restart: Restart a container"
9 echo " destroy: Stop and remove a container"
4a5acf8c 10 echo " enter: Open a shell to run commands inside the container"
c2d3ee4a 11 echo " logs: View the Docker logs for a container"
5cb39519
JA
12 echo " bootstrap: Bootstrap a container for the config based on a template"
13 echo " rebuild: Rebuild a container (destroy old, bootstrap, start new)"
14 echo " cleanup: Remove all containers that have stopped for > 24 hours"
15 echo
16 echo "Options:"
1f656469 17 echo " --skip-prereqs Don't check launcher prerequisites"
1f656469 18 echo " --docker-args Extra arguments to pass when running docker"
cad2919f 19 echo " --skip-mac-address Don't assign a mac address"
5cb39519
JA
20 exit 1
21}
22
7e738616
S
23command=$1
24config=$2
65573a0e 25user_args=""
87c4f221 26
1f656469 27while [ ${#} -gt 0 ]; do
65573a0e 28 case "${1}" in
19e3a6c0
S
29 --debug)
30 DEBUG="1"
31 ;;
1f656469 32 --skip-prereqs)
4f36bb43 33 SKIP_PREREQS="1"
1f656469 34 ;;
cad2919f
GXT
35 --skip-mac-address)
36 SKIP_MAC_ADDRESS="1"
37 ;;
1f656469
GXT
38 --docker-args)
39 user_args="$2"
40 shift
41 ;;
1f656469
GXT
42 esac
43
44 shift 1
45done
55d17203 46
87756d6d
EH
47# Docker doesn't like uppercase characters, spaces or special characters, catch it now before we build everything out and then find out
48re='[A-Z/ !@#$%^&*()+~`=]'
49if [[ $config =~ $re ]];
50 then
8877f99e 51 echo
87756d6d
EH
52 echo "ERROR: Config name must not contain upper case characters, spaces or special characters. Correct config name and rerun $0."
53 echo
54 exit 1
55fi
56
7936ebaa 57cd "$(dirname "$0")"
55d17203 58
a28dd1dc
JA
59docker_min_version='1.8.0'
60docker_rec_version='1.8.0'
6828238a
JP
61git_min_version='1.8.0'
62git_rec_version='1.8.0'
60668406 63
8dea575c 64config_file=containers/"$config".yml
5201a40c 65cidbootstrap=cids/"$config"_bootstrap.cid
5efded6a 66local_discourse=local_discourse
2d337999 67image=discourse/discourse:1.3.5
4807b1b8 68docker_path=`which docker.io || which docker`
6828238a 69git_path=`which git`
8877f99e 70
e0fd1f5b
TB
71if [ "${SUPERVISED}" = "true" ]; then
72 restart_policy="--restart=no"
73 attach_on_start="-a"
74 attach_on_run="-a stdout -a stderr"
75else
76 attach_on_run="-d"
77fi
78
f2a3edee
AY
79if [ -n "$DOCKER_HOST" ]; then
80 docker_ip=`sed -e 's/^tcp:\/\/\(.*\):.*$/\1/' <<< "$DOCKER_HOST"`
81elif [ -x "$(which ip 2>/dev/null)" ]; then
813fef38 82 docker_ip=`ip addr show docker0 | \
03bb0735
LG
83 grep 'inet ' | \
84 awk '{ split($2,a,"/"); print a[1] }';`
85else
813fef38 86 docker_ip=`ifconfig | \
03bb0735
LG
87 grep -B1 "inet addr" | \
88 awk '{ if ( $1 == "inet" ) { print $2 } else if ( $2 == "Link" ) { printf "%s:" ,$1 } }' | \
89 grep docker0 | \
90 awk -F: '{ print $3 }';`
91fi
80c11be3 92
60668406
DP
93compare_version() {
94 declare -a ver_a
95 declare -a ver_b
96 IFS=. read -a ver_a <<< "$1"
97 IFS=. read -a ver_b <<< "$2"
98
99 while [[ -n $ver_a ]]; do
100 if (( ver_a > ver_b )); then
101 return 0
102 elif (( ver_b > ver_a )); then
103 return 1
104 else
105 unset ver_a[0]
106 ver_a=("${ver_a[@]}")
107 unset ver_b[0]
108 ver_b=("${ver_b[@]}")
109 fi
110 done
111 return 1 # They are equal
112}
113
665468eb
JA
114
115install_docker() {
c2d3ee4a 116 echo "Docker is not installed, you will need to install Docker in order to run Launcher"
bf6d49b5 117 echo "See https://docs.docker.com/installation/"
665468eb
JA
118 exit 1
119}
120
87c4f221 121check_prereqs() {
794e44d5
GXT
122
123 if [ -z $docker_path ]; then
665468eb
JA
124 install_docker
125 fi
a3e18d95 126
e741295a 127 # 1. docker daemon running?
30835a52
S
128 # we send stderr to /dev/null cause we don't care about warnings,
129 # it usually complains about swap which does not matter
130 test=`$docker_path info 2> /dev/null`
e741295a
MB
131 if [[ $? -ne 0 ]] ; then
132 echo "Cannot connect to the docker daemon - verify it is running and you have access"
133 exit 1
134 fi
135
185e78c6
S
136 # 2. running aufs or btrfs
137 test=`$docker_path info 2> /dev/null | grep 'Driver: '`
48f22d14
S
138 if [[ "$test" =~ [aufs|btrfs|zfs|overlay] ]] ; then : ; else
139 echo "Your Docker installation is not using a supported filesystem if we were to proceed you may have a broken install."
140 echo "aufs is the recommended filesystem you should be using (zfs/btrfs and overlay may work as well)"
141 echo "You can tell what filesystem you are using by running \"docker info\" and looking at the driver"
5dfdf9a3
JA
142 echo
143 echo "If you wish to continue anyway using your existing unsupported filesystem, "
48f22d14
S
144 echo "read the source code of launcher and figure out how to bypass this."
145 exit 1
a3e18d95
S
146 fi
147
60668406
DP
148 # 3. running recommended docker version
149 test=($($docker_path --version)) # Get docker version string
150 test=${test[2]//,/} # Get version alone and strip comma if exists
a3e18d95 151
87c4f221 152 # At least minimum docker version
cf00fce0 153 if compare_version "${docker_min_version}" "${test}"; then
60668406 154 echo "ERROR: Docker version ${test} not supported, please upgrade to at least ${docker_min_version}, or recommended ${docker_rec_version}"
a3e18d95
S
155 exit 1
156 fi
157
87c4f221 158 # Recommend newer docker version
60668406
DP
159 if compare_version "${docker_rec_version}" "${test}"; then
160 echo "WARNING: Docker version ${test} deprecated, recommend upgrade to ${docker_rec_version} or newer."
161 fi
162
405948ee
S
163 # 4. discourse docker image is downloaded
164 test=`$docker_path images | awk '{print $1 ":" $2 }' | grep "$image"`
165
166 if [ -z "$test" ]; then
167 echo
168 echo "WARNING: We are about to start downloading the Discourse base image"
169 echo "This process may take anywhere between a few minutes to an hour, depending on your network speed"
170 echo
171 echo "Please be patient"
172 echo
405948ee 173 fi
405948ee 174
6828238a
JP
175 # 5. running recommended git version
176 test=($($git_path --version)) # Get git version string
177 test=${test[2]//,/} # Get version alone and strip comma if exists
178
179 # At least minimum version
180 if compare_version "${git_min_version}" "${test}"; then
181 echo "ERROR: Git version ${test} not supported, please upgrade to at least ${git_min_version}, or recommended ${git_rec_version}"
182 exit 1
183 fi
184
185 # Recommend best version
186 if compare_version "${git_rec_version}" "${test}"; then
187 echo "WARNING: Git version ${test} deprecated, recommend upgrade to ${git_rec_version} or newer."
188 fi
189
190 # 6. able to attach stderr / out / tty
e02c1511 191 test=`$docker_path run $user_args -i --rm -a stdout -a stderr $image echo working`
a3e18d95
S
192 if [[ "$test" =~ "working" ]] ; then : ; else
193 echo "Your Docker installation is not working correctly"
194 echo
195 echo "See: https://meta.discourse.org/t/docker-error-on-bootstrap/13657/18?u=sam"
196 exit 1
197 fi
4770834b 198
6e784be6
MP
199}
200
6828238a 201
1f656469 202if [ -z "$SKIP_PREREQS" ] ; then
87c4f221 203 check_prereqs
55d17203 204fi
a3e18d95 205
60f9f04c
S
206host_run() {
207 read -r -d '' env_ruby << 'RUBY'
208 require 'yaml'
209
210 input = STDIN.readlines.join
211 yaml = YAML.load(input)
212
213 if host_run = yaml['host_run']
214 params = yaml['params'] || {}
215 host_run.each do |run|
216 params.each do |k,v|
217 run = run.gsub("$#{k}", v)
218 end
219 STDOUT.write "#{run}--SEP--"
220 end
221 end
222RUBY
223
e02c1511 224 host_run=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e "$env_ruby"`
60f9f04c
S
225
226 while [ "$host_run" ] ; do
227 iter=${host_run%%--SEP--*}
228 echo
229 echo "Host run: $iter"
230 $iter || exit 1
231 echo
232 host_run="${host_run#*--SEP--}"
233 done
234}
235
236
d90671f3 237set_volumes() {
e02c1511 238 volumes=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e \
d90671f3
SS
239 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['volumes'].map{|v| '-v ' << v['volume']['host'] << ':' << v['volume']['guest'] << ' '}.join"`
240}
241
41daa523 242set_links() {
e02c1511 243 links=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e \
41daa523 244 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['links'].map{|l| '--link ' << l['link']['name'] << ':' << l['link']['alias'] << ' '}.join"`
245}
246
06310c73
GXT
247find_templates() {
248 local templates=`cat $1 | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
7f77c274
SS
249 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['templates']"`
250
06310c73
GXT
251 local arrTemplates=${templates// / }
252
2ec550f7 253 if [ ! -z "$templates" ]; then
06310c73
GXT
254 for template in "${arrTemplates[@]}"
255 do
256 local nested_templates=$(find_templates $template)
257
258 if [ ! -z "$nested_templates" ]; then
259 templates="$templates $nested_templates"
260 fi
261 done
262
263 echo $templates
264 else
265 echo ""
266 fi
267}
268
269set_template_info() {
270 templates=$(find_templates $config_file)
271
7f77c274
SS
272 arrTemplates=(${templates// / })
273 config_data=$(cat $config_file)
274
275 input="hack: true"
276
7f77c274
SS
277 for template in "${arrTemplates[@]}"
278 do
279 [ ! -z $template ] && {
280 input="$input _FILE_SEPERATOR_ $(cat $template)"
281 }
282 done
283
284 # we always want our config file last so it takes priority
285 input="$input _FILE_SEPERATOR_ $config_data"
286
287 read -r -d '' env_ruby << 'RUBY'
288 require 'yaml'
289
290 input=STDIN.readlines.join
3cb3d9c4
S
291 # default to UTF-8 for the dbs sake
292 env = {'LANG' => 'en_US.UTF-8'}
7f77c274
SS
293 input.split('_FILE_SEPERATOR_').each do |yml|
294 yml.strip!
295 begin
296 env.merge!(YAML.load(yml)['env'] || {})
f3824347 297 rescue Psych::SyntaxError => e
298 puts e
299 puts "*ERROR."
7f77c274
SS
300 rescue => e
301 puts yml
302 p e
303 end
304 end
4b563ee8 305 puts env.map{|k,v| "-e\n#{k}=#{v}" }.join("\n")
7f77c274
SS
306RUBY
307
e02c1511 308 raw=`exec echo "$input" | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e "$env_ruby"`
4b563ee8
SS
309
310 env=()
f3824347 311 ok=1
4b563ee8 312 while read i; do
f3824347 313 if [ "$i" == "*ERROR." ]; then
314 ok=0
315 elif [ -n "$i" ]; then
16f2d250
S
316 env[${#env[@]}]=$i
317 fi
4b563ee8
SS
318 done <<< "$raw"
319
f3824347 320 if [ "$ok" -ne 1 ]; then
321 echo "${env[@]}"
c2d3ee4a 322 echo "YAML syntax error. Please check your containers/*.yml config files."
f3824347 323 exit 1
324 fi
7f77c274
SS
325}
326
665468eb 327if [ -z $docker_path ]; then
52388b87 328 install_docker
665468eb 329fi
52388b87 330
de869404 331[ "$command" == "cleanup" ] && {
c692f743
L
332 echo
333 echo "The following command will"
334 echo "- Delete all docker images for old containers"
335 echo "- Delete all stopped and orphan containers"
336 echo
337 read -p "Are you sure (Y/n): " -n 1 -r && echo
338 if [[ $REPLY =~ ^[Yy]$ || ! $REPLY ]]
339 then
30835a52 340 space=$(df /var/lib/docker | awk '{ print $4 }' | grep -v Available)
29a35d1b 341 echo "Starting Cleanup (bytes free $space)"
30835a52 342
29a35d1b 343 STATE_DIR=./.gc-state scripts/docker-gc
30835a52 344
29a35d1b
S
345 space=$(df /var/lib/docker | awk '{ print $4 }' | grep -v Available)
346 echo "Finished Cleanup (bytes free $space)"
30835a52 347
c692f743 348 else
30835a52 349 exit 1
c692f743 350 fi
a8b66f98
L
351 exit 0
352}
5f803fb4 353
65573a0e
GXT
354if [ -z "$command" -a -z "$config" ]; then
355 usage
356fi
357
358if [ ! "$command" == "setup" ]; then
359 if [[ ! -e $config_file ]]; then
7e738616 360 echo "Config file was not found, ensure $config_file exists"
5dfdf9a3 361 echo
71680b16 362 echo "Available configs ( `cd containers && ls -dm *.yml | tr -s '\n' ' ' | awk '{ gsub(/\.yml/, ""); print }'`)"
7e738616 363 exit 1
65573a0e 364 fi
7e738616
S
365fi
366
e2ed1fb6
S
367docker_version=($($docker_path --version))
368docker_version=${test[2]//,/}
69545efd 369restart_policy=${restart_policy:---restart=always}
e2ed1fb6 370
30835a52 371set_existing_container(){
295e8f19 372 existing=`$docker_path ps -a | awk '{ print $1, $(NF) }' | grep " $config$" | awk '{ print $1 }'`
337a89aa
S
373}
374
665468eb 375run_stop() {
337a89aa 376
30835a52 377 set_existing_container
60f9f04c 378
30835a52 379 if [ ! -z $existing ]
337a89aa 380 then
30835a52
S
381 (
382 set -x
383 $docker_path stop -t 10 $config
384 )
337a89aa 385 else
30835a52
S
386 echo "$config was not started !"
387 exit 1
388 fi
389}
337a89aa 390
8877f99e
S
391set_run_image() {
392 run_image=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
393 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['run_image']"`
394
395 if [ -z "$run_image" ]; then
396 run_image="$local_discourse/$config"
397 fi
398}
399
400set_boot_command() {
401 boot_command=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
402 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['boot_command']"`
403
404 if [ -z "$boot_command" ]; then
405
406 no_boot_command=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
407 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['no_boot_command']"`
408
409 if [ -z "$no_boot_command" ]; then
410 boot_command="/sbin/boot"
411 fi
412 fi
413}
414
665468eb 415run_start() {
337a89aa 416
295e8f19
S
417 existing=`$docker_path ps | awk '{ print $1, $(NF) }' | grep " $config$" | awk '{ print $1 }'`
418 echo $existing
30835a52
S
419 if [ ! -z $existing ]
420 then
421 echo "Nothing to do, your container has already started!"
eac33309 422 exit 0
30835a52
S
423 fi
424
295e8f19 425 existing=`$docker_path ps -a | awk '{ print $1, $(NF) }' | grep " $config$" | awk '{ print $1 }'`
30835a52
S
426 if [ ! -z $existing ]
427 then
428 echo "starting up existing container"
429 (
430 set -x
431 $docker_path start $config
432 )
433 exit 0
434 fi
435
436 host_run
1f656469 437
afec9a51
GXT
438 ports=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e \
439 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['expose'].map{|p| \"-p #{p}\"}.join(' ')"`
440
8b617e6e
PG
441 docker_args=`cat $config_file | $docker_path run $user_args --rm -i -a stdout -a stdin $image ruby -e \
442 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['docker_args']"`
443
30835a52
S
444 set_template_info
445 set_volumes
446 set_links
8877f99e
S
447 set_run_image
448 set_boot_command
30835a52 449
c6dd6f9d
FB
450 # get hostname and settings from container configuration
451 for envar in "${env[@]}"
452 do
453 if [[ $envar == DOCKER_USE_HOSTNAME* ]] || [[ $envar == DISCOURSE_HOSTNAME* ]]
454 then
455 # use as environment variable
456 eval $envar
457 fi
458 done
459
30835a52 460 (
c834fdd1 461 hostname=`hostname -s`
c6dd6f9d
FB
462 # overwrite hostname
463 if [ "$DOCKER_USE_HOSTNAME" = "true" ]
464 then
465 hostname=$DISCOURSE_HOSTNAME
466 else
467 hostname=$hostname-$config
468 fi
469
a0606001
S
470 # we got to normalize so we only have allowed strings, this is more comprehensive but lets see how bash does first
471 # hostname=`$docker_path run $user_args --rm $image ruby -e 'print ARGV[0].gsub(/[^a-zA-Z-]/, "-")' $hostname`
472 # docker added more hostname rules
fd2e7637 473 hostname=${hostname//_/-}
a0606001 474
cad2919f
GXT
475
476 if [ -z "$SKIP_MAC_ADDRESS" ] ; then
477 mac_address="--mac-address $($docker_path run $user_args -i --rm -a stdout -a stderr $image /bin/sh -c "echo $hostname | md5sum | sed 's/^\(..\)\(..\)\(..\)\(..\)\(..\).*$/02:\1:\2:\3:\4:\5/'")"
478 fi
d2a86ee1 479
30835a52 480 set -x
c6dd6f9d 481 $docker_path run $user_args $links $attach_on_run $restart_policy "${env[@]}" -h "$hostname" \
d2a86ee1
MP
482 -e DOCKER_HOST_IP=$docker_ip --name $config -t $ports $volumes $mac_address $docker_args \
483 $run_image $boot_command
30835a52
S
484
485 )
486 exit 0
337a89aa
S
487
488}
489
ec8f8b83 490
665468eb 491run_bootstrap() {
794e44d5 492
5dfdf9a3 493 # I got no frigging clue what this does, ask Sam Saffron. It RUNS STUFF ON THE HOST I GUESS?
60f9f04c
S
494 host_run
495
680dd4ea
S
496 # Is the image available?
497 # If not, pull it here so the user is aware what's happening.
4807b1b8 498 $docker_path history $image >/dev/null 2>&1 || $docker_path pull $image
88126eba 499
680dd4ea 500 set_template_info
93149421 501
e02c1511 502 base_image=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
680dd4ea 503 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['base_image']"`
93149421 504
e02c1511 505 update_pups=`cat $config_file | $docker_path run $user_args --rm -i -a stdin -a stdout $image ruby -e \
680dd4ea 506 "require 'yaml'; puts YAML.load(STDIN.readlines.join)['update_pups']"`
b9c7b50e 507
680dd4ea
S
508 if [[ ! X"" = X"$base_image" ]]; then
509 image=$base_image
510 fi
b9c7b50e 511
680dd4ea 512 set_volumes
41daa523 513 set_links
b9c7b50e 514
680dd4ea 515 rm -f $cidbootstrap
d90671f3 516
680dd4ea
S
517 run_command="cd /pups &&"
518 if [[ ! "false" = $update_pups ]]; then
519 run_command="$run_command git pull &&"
520 fi
521 run_command="$run_command /pups/bin/pups --stdin"
2162f1d4 522
680dd4ea 523 echo $run_command
b9c7b50e 524
b4ab14c2 525 unset ERR
e02c1511 526 (exec echo "$input" | $docker_path run $user_args $links "${env[@]}" -e DOCKER_HOST_IP=$docker_ip --cidfile $cidbootstrap -i -a stdin -a stdout -a stderr $volumes $image \
b4ab14c2
S
527 /bin/bash -c "$run_command") || ERR=$?
528
529 unset FAILED
530 # magic exit code that indicates a retry
531 if [[ "$ERR" == 77 ]]; then
382c8e40
S
532 $docker_path rm `cat $cidbootstrap`
533 rm $cidbootstrap
b4ab14c2 534 exit 77
382c8e40 535 elif [[ "$ERR" > 0 ]]; then
b4ab14c2
S
536 FAILED=TRUE
537 fi
19e3a6c0
S
538
539 if [[ $FAILED = "TRUE" ]]; then
540 if [[ ! -z "$DEBUG" ]]; then
541 $docker_path commit `cat $cidbootstrap` $local_discourse/$config-debug || echo 'FAILED TO COMMIT'
542 echo "** DEBUG ** Maintaining image for diagnostics $local_discourse/$config-debug"
543 fi
88126eba 544
19e3a6c0
S
545 $docker_path rm `cat $cidbootstrap`
546 rm $cidbootstrap
547 echo "** FAILED TO BOOTSTRAP ** please scroll up and look for earlier error messages, there may be more than one"
548 exit 1
549 fi
9fb5f2d3 550
680dd4ea 551 sleep 5
2162f1d4 552
4807b1b8
MB
553 $docker_path commit `cat $cidbootstrap` $local_discourse/$config || echo 'FAILED TO COMMIT'
554 $docker_path rm `cat $cidbootstrap` && rm $cidbootstrap
680dd4ea 555}
9fb5f2d3 556
8877f99e
S
557
558
680dd4ea
S
559case "$command" in
560 bootstrap)
680dd4ea 561 run_bootstrap
2dd2e330 562 echo "Successfully bootstrapped, to startup use ./launcher start $config"
4b3aebe1 563 exit 0
5f803fb4 564 ;;
1acce9e4 565
2fc6ff36 566 enter)
0c456e8c 567 exec $docker_path exec -it $config /bin/bash --login
2fc6ff36
S
568 ;;
569
5f803fb4 570 stop)
337a89aa
S
571 run_stop
572 exit 0
5f803fb4 573 ;;
7e738616 574
5f803fb4 575 logs)
7e738616 576
30835a52
S
577 $docker_path logs $config
578 exit 0
5f803fb4 579 ;;
7e738616 580
337a89aa
S
581 restart)
582 run_stop
583 run_start
584 exit 0
585 ;;
80c11be3 586
337a89aa
S
587 start)
588 run_start
589 exit 0
5f803fb4 590 ;;
7e738616 591
680dd4ea 592 rebuild)
4b6456ef 593 if [ "$(git symbolic-ref --short HEAD)" == "master" ]; then
c2d3ee4a 594 echo "Ensuring launcher is up to date"
098533cb
S
595
596 git remote update
597
598 LOCAL=$(git rev-parse @)
599 REMOTE=$(git rev-parse @{u})
600 BASE=$(git merge-base @ @{u})
601
602 if [ $LOCAL = $REMOTE ]; then
c2d3ee4a 603 echo "Launcher is up-to-date"
098533cb
S
604
605 elif [ $LOCAL = $BASE ]; then
c2d3ee4a 606 echo "Updating Launcher"
098533cb
S
607 git pull || (echo 'failed to update' && exit 1)
608 exec /bin/bash $0 $@
609
610 elif [ $REMOTE = $BASE ]; then
c2d3ee4a 611 echo "Your version of Launcher is ahead of origin"
098533cb
S
612
613 else
c2d3ee4a 614 echo "Launcher has diverged source, this is only expected in Dev mode"
098533cb
S
615 fi
616
4b6456ef 617 fi
30835a52
S
618
619 set_existing_container
620
621 if [ ! -z $existing ]
680dd4ea
S
622 then
623 echo "Stopping old container"
30835a52
S
624 (
625 set -x
626 $docker_path stop -t 10 $config
627 )
680dd4ea
S
628 fi
629
630 run_bootstrap
631
30835a52 632 if [ ! -z $existing ]
680dd4ea 633 then
30835a52
S
634 echo "Removing old container"
635 (
636 set -x
637 $docker_path rm $config
638 )
680dd4ea
S
639 fi
640
641 run_start
642 exit 0
643 ;;
644
7e738616 645
5f803fb4 646 destroy)
30835a52
S
647 (set -x; $docker_path stop -t 10 $config && $docker_path rm $config) || (echo "$config was not found" && exit 0)
648 exit 0
5f803fb4
SS
649 ;;
650esac
7e738616 651
5f803fb4 652usage